#ifndef CLIB_FEELIN_PROTOS_H
#define CLIB_FEELIN_PROTOS_H

/*
**    $VER: feelin_protos.h 7.0 (2004/07/18)
**
**    C prototypes definitions
**
**     2001-2004 Olivier LAVIALE (gofromiel@numericable.fr)
*/

#ifndef     EXEC_TYPES_H
#include    <exec/types.h>
#endif

struct FeelinPool *     F_CreatePool            (ULONG nFlags, ULONG nItemSize, ULONG nItemNumber);
void                    F_DeletePool            (struct FeelinPool *psPool);
APTR                    F_New                   (ULONG nSize);
APTR                    F_NewP                  (struct FeelinPool *psPool,ULONG nSize);
void                    F_Dispose               (APTR paMem);
void                    F_DisposeP              (struct FeelinPool *psPool,APTR paMem);
void                    F_OPool                 (struct FeelinPool *psPool);
void                    F_SPool                 (struct FeelinPool *psPool);
void                    F_RPool                 (struct FeelinPool *psPool);
void                    F_NamePool              (struct FeelinPool *psPool,STRPTR pcName);
APTR                    F_FindChunk             (APTR paMem);

APTR                    F_LinkTail              (struct FeelinList *psList,struct FeelinNode *psNode);
APTR                    F_LinkHead              (struct FeelinList *psList,struct FeelinNode *psNode);
APTR                    F_LinkInsert            (struct FeelinList *psList,struct FeelinNode *psNode, struct FeelinNode *psPrev);
APTR                    F_LinkMove              (struct FeelinList *psList,struct FeelinNode *psNode, struct FeelinNode *psPrev);
APTR                    F_LinkRemove            (struct FeelinList *psList,struct FeelinNode *psNode);
APTR                    F_LinkMember            (struct FeelinList *psList,struct FeelinNode *psNode);
APTR                    F_NextNode              (APTR paObjptrptr);

void                    F_Log                   (UBYTE nLevel,STRPTR pcFormat, ...);
void                    F_LogA                  (UBYTE nLevel,STRPTR pcFormat,APTR pnArgs);
void                    F_Alert                 (STRPTR pcTitle,STRPTR pcBody, ...);
void                    F_AlertA                (STRPTR pcTitle,STRPTR pcBody, APTR pnArgs);

ULONG                   F_StrDec                (STRPTR pcStr);
ULONG                   F_StrLen                (STRPTR pcStr);
BOOL                    F_StrCmp                (STRPTR pcStr1,STRPTR pcStr2,ULONG nLength);

ULONG                   F_RawFormat             (APTR pcBuf,const STRPTR pcStr, ...);
ULONG                   F_RawFormatA            (APTR pcBuf,const STRPTR pcStr,APTR pnArgs);

struct FeelinClass *    F_FindClass             (STRPTR pcID);
struct FeelinClass *    F_OpenClass             (STRPTR pcID);
void                    F_CloseClass            (struct FeelinClass *psClass);
struct FeelinClass *    F_CreateClass           (...);
struct FeelinClass *    F_CreateClassA          (struct TagItem *psTags);
void                    F_DeleteClass           (struct FeelinClass *psClass);

ULONG                   F_Do                    (APTR paObj,ULONG nMethod, ...);
ULONG                   F_DoA                   (APTR paObj,ULONG nMethod,APTR pnArgs);
ULONG                   F_ClassDo               (struct FeelinClass *psClass,APTR paObj,ULONG nMethod, ...);
ULONG                   F_ClassDoA              (struct FeelinClass *psClass,APTR paObj,ULONG nMethod,APTR pnArgs);
ULONG                   F_SuperDo               (struct FeelinClass *psClass,APTR paObj,ULONG nMethod, ...);
ULONG                   F_SuperDoA              (struct FeelinClass *psClass,APTR paObj,ULONG nMethod,APTR pnArgs);

APTR                    F_NewObj                (STRPTR pcID, ...);
APTR                    F_NewObjA               (STRPTR pcID, struct TagItem *psTags);
APTR                    F_MakeObj               (ULONG nType, ...);
APTR                    F_MakeObjA              (ULONG nType,APTR pnParams);
void                    F_DisposeObj            (APTR paObj);

ULONG                   F_Get                   (APTR paObj,ULONG nAttr);
void                    F_Set                   (APTR paObj,ULONG nAttr,ULONG nData);

void                    F_Draw                  (APTR paObj,ULONG nFlags);
void                    F_AskMinMax             (APTR paObj);
void                    F_Layout                (APTR paObj,WORD nX,WORD nY,WORD nW,WORD nH,ULONG nFlags);
void                    F_Erase                 (APTR paObj,WORD nX1,WORD nY1,WORD nX2,WORD nY2,ULONG nFlags);

struct FeelinServer *   F_FindServer            (STRPTR Name);
struct FeelinServer *   F_OpenServer            (STRPTR Name);
void                    F_CloseServer           (struct FeelinServer *Server);
struct FeelinServer *   F_CreateServer          (...);
struct FeelinServer *   F_CreateServerA         (struct TagItem *Tags);
void                    F_DeleteServer          (struct FeelinServer *Server);
ULONG                   F_SendServerMessage     (struct FeelinServer *Server, ULONG nAction, ...);
ULONG                   F_SendServerMessageA    (struct FeelinServer *Server, ULONG nAction, APTR pnArgs);

LONG                    F_DynamicCreate         (struct FeelinClass *Class);
void                    F_DynamicDelete         (struct FeelinClass *Class);
ULONG                   F_DynamicFindID         (STRPTR String);
void                    F_DynamicResolveTable   (struct FeelinDynamicEntry *Entries);
LONG                    F_DynamicAddAutoTable   (struct FeelinDynamicEntry *Table);
void                    F_DynamicRemAutoTable   (struct FeelinDynamicEntry *Table);
struct TagItem *        F_DynamicNTI            (struct TagItem **,struct TagItem *,struct FeelinClass *);
struct TagItem *        F_DynamicFTI            (ULONG Attribute,struct TagItem *);
ULONG                   F_DynamicGTD            (ULONG Attribute,ULONG Default,struct TagItem *);

struct FeelinHashTable *    F_HashCreate            (ULONG Size);
void                        F_HashDelete            (struct FeelinHashTable *Table);
struct FeelinHashLink *     F_HashFind              (struct FeelinHashTable *Table,UBYTE *Key,ULONG KeyLenght,ULONG *HashValuePtr);
struct FeelinHashLink *     F_HashAddLink           (struct FeelinHashTable *Table,struct FeelinHashLink *Link);
void                        F_HashRemLink           (struct FeelinHashTable *Table,struct FeelinHashLink *Link);
struct FeelinHashLink *     F_HashAdd               (struct FeelinHashTable *Table,UBYTE *Key,ULONG KeyLength,APTR Data);
void                        F_HashRem               (struct FeelinHashTable *Table,UBYTE *Key,ULONG KeyLength);

#endif   /* CLIB_FEELIN_PROTOS_H */
